<?php
class AVUP_Json_Item {
	protected $item,
				$item_all_data,
				$params;

	function __construct( $item_data ) {
		$this->item_all_data = (array) $item_data;
	}

	public function init( $params, $feed_infos ) {

		if ( empty( $params ) || empty( $feed_infos ) ) {
			return false;
		}

		$params     = json_decode( json_encode( $params ), true );
		$feed_infos = json_decode( json_encode( $feed_infos ), true );
		$partner_id = $params['partner']['id'];

		$this->params = $params;

		$this->item['id']              = $this->get_partner_feed_infos( 'feed_item_id', $partner_id, $feed_infos );
		$this->item['title']           = $this->get_partner_feed_infos( 'feed_item_title', $partner_id, $feed_infos );
		$this->item['desc']            = $this->get_partner_feed_infos( 'feed_item_desc', $partner_id, $feed_infos );
		$this->item['tags']            = $this->get_partner_feed_infos( 'feed_item_tags', $partner_id, $feed_infos );
		$this->item['duration']        = $this->get_partner_feed_infos( 'feed_item_length', $partner_id, $feed_infos );
		$this->item['duration_format'] = $this->get_partner_feed_infos( 'feed_item_length_format', $partner_id, $feed_infos );
		$this->item['thumb_url']       = $this->get_partner_feed_infos( 'feed_item_thumb_url', $partner_id, $feed_infos );
		$this->item['thumbs_urls']     = $this->get_partner_feed_infos( 'feed_item_thumbs_urls', $partner_id, $feed_infos );
		$this->item['trailer_url']     = $this->get_partner_feed_infos( 'feed_item_trailer_url', $partner_id, $feed_infos );
		$this->item['video_url']       = $this->get_partner_feed_infos( 'feed_item_video_url', $partner_id, $feed_infos );
		$this->item['tracking_url']    = $this->get_partner_feed_infos( 'feed_item_join_url', $partner_id, $feed_infos );
		$this->item['code']            = $this->get_partner_feed_infos( 'feed_item_code', $partner_id, $feed_infos );
		$this->item['actors']          = $this->get_partner_feed_infos( 'feed_item_actors', $partner_id, $feed_infos );
	}

	public function get_id() {
		return AVUP_Item::get_id( $this->item );
	}

	public function is_valid() {
		return AVUP_Item::is_valid( $this->item );
	}

	public function get_data_for_js() {
		return AVUP_Item::get_data_for_js( $this->item );
	}

	public function get_data_for_json() {
		return AVUP_Item::get_data_for_json( $this->item );
	}

	private function get_partner_feed_infos( $partner_feed_item, $partner_id, $feed_infos ) {
		$output         = null;
		$feed_item_type = isset( $feed_infos[ $partner_feed_item ] ) ? key( $feed_infos[ $partner_feed_item ] ) : null;
		$short_item     = '';

		if ( isset( $feed_infos[ $partner_feed_item ][ $feed_item_type ] ) ) {
			$short_item = $feed_infos[ $partner_feed_item ][ $feed_item_type ];
			$results    = array();
			preg_match_all( '/<%(.+)%>/U', $short_item, $results );
			foreach ( $results[1] as $result ) {
				$short_item = str_replace( '<%' . $result . '%>', eval( 'return ' . $result . ';' ), $short_item );
			}
			unset( $results );
			switch ( $feed_item_type ) {

				case 'node':
					if ( is_array( $this->item_all_data[ $short_item ] ) ) {
						$output = isset( $this->item_all_data[ $short_item ][0] ) ? $this->item_all_data[ $short_item ][0] : '';
					} else {
						$struct = explode( '/', $short_item );
						if ( count( $struct ) == 2 ) {
							$output = $this->item_all_data[ $struct[0] ][ $struct[1] ];
						} else {
							$output = isset( $this->item_all_data[ $short_item ] ) ? $this->item_all_data[ $short_item ] : '';
						}
					}
					break;

				case 'node_array':
					$struct = explode( '/', $short_item );
					if ( count( $struct ) == 2 ) {
						$output = implode( ',', (array) $this->item_all_data[ $struct[0] ][ $struct[1] ] );
					} else {
						$output = implode( ',', (array) $this->item_all_data[ $short_item ] );
					}
					break;

				case 'node_foreach':
					$exploded_final_node = explode( 'foreach:', $short_item );
					$final_node          = $exploded_final_node[1];
					$exploded_path       = explode( '/', $exploded_final_node[0] );
					$path                = $exploded_path[0];
					$output              = array();
					foreach ( (array) $this->item_all_data[ $path ] as $key => $value ) {
						if ( $final_node == '{value}' ) {
							if ( $value != '' ) {
								$output[] = $value;
							}
						} else {
							$output[] = $value[ $final_node ];
						}
					}
					$output = implode( ',', (array) $output );
					break;

				default:
					$output = $short_item;
					break;

			}
		}
		if ( ! $output ) {
			return false;
		}

		// redtube
		if ( $partner_id == 'redtube' ) {
			if ( $partner_feed_item == 'feed_item_thumb_url' ) {
				$output = str_replace( array( 'eGJF8f', 'e0YH8f' ), 'eWgr9f', $output );
			}
		}

		return AVUP_Item::clean_string( $output );
	}
}
