//jetpack fix
_.contains = _.includes;
window.lodash = _.noConflict();

window.addEventListener('load', AVUP_pageImportVideos, false);
function AVUP_pageImportVideos() {

    if (document.getElementById('import-videos')) {
        jQuery('body').tooltip({
            selector: '[rel="tooltip"]',
            //container: 'body',
            trigger: 'hover'
        });

        //sticky header
        if( jQuery('#videos-found').length > 0 )  {
            var $headerNav = jQuery('#videos-found-header');
        }

        var stickNav = function(){
            if( jQuery('#videos-found').is(':visible') )  {
                var stickyNavTop = jQuery('#videos-found').offset().top - $headerNav.height() - 32;
                var scrollTop = jQuery(window).scrollTop()
                var $totalWidth = jQuery('#import-videos').width();
                if (scrollTop > stickyNavTop ) {
                    jQuery('#videos-found-header').addClass('sticky').width($totalWidth);
                    jQuery('#sticky-space').height('96px');
                } else {
                    jQuery('#videos-found-header').removeClass('sticky');
                    jQuery('#videos-found-header').width('100%');
                    jQuery('#sticky-space').height('0px');
                }
            }
        }

        //on window load / scroll / resize
        jQuery(window).on('load scroll resize', function(e) {
            stickNav();
        });
        
        //vue script
        var importVideos = new Vue({
            el: '#import-videos',
            data: {
                //loading
                loading: {
                    loadingData: false,
                },
                ///data
                dataLoaded: false,
                data: {},
                //Selected WP categories and Post Status
                selectedWPCat: 0,
                selectedPostsStatus: 0,
                newWpCategoryName: '',
                addingNewWpCategory: false,
                //videos
                linesLimit: 5 * 4, // change this value at your own risk
                textareaVideosUrls: '',
                parsingTextarea: false,
                validVideos: [],
                videos: [],
                videosResponses: [],
                searchingVideos: false,
                videosHasBeenSearched: false,
                videosSearchedErrors: {},
                //current video
                currentVideo: '',
                currentVideoUrl: '',
                currentVideoEmbed: '',
                expandedThumb: '',
                //states
                importingVideos: false,
                savedCheckedVideosCounter: 0,
                //misc
                displayType : 'cards'
            },
            mounted: function () {
                var self = this;
                this.loading.loadingData = true;
                this.$http.post(
                    AVUP_import_videos.ajax.url, {
                        action: 'AVUP_load_import_videos_data',
                        nonce: AVUP_import_videos.ajax.nonce
                    }, {
                        emulateJSON: true
                    })
                    .then( function (response) {
                        // success callback
                        this.data = response.body;
                    }, function (response) {
                        // error callback
                        console.error(response);
                    }).then( function () {
                        this.loading.loadingData = false;
                        this.dataLoaded = true;
                    });

                this.resetSearch();

                //stop video when video modal is hidden
                jQuery('body').on('hidden.bs.modal', '.modal', function (e) {
                    self.currentVideoUrl = '';
                    self.currentVideoEmbed = '';
                    self.expandedThumb = '';
                });

                jQuery('body').on('shown.bs.tab', 'a[data-toggle="tab"]', function (e) {
                    if (jQuery(e.relatedTarget).attr('href') == '#current-video-data') {
                        self.currentVideoUrl = '';
                        self.currentVideoEmbed = '';
                        self.expandedThumb = '';
                    } else {
                        self.currentVideoUrl = self.currentVideo.video_url;
                        self.currentVideoEmbed = self.currentVideo.embed;
                    }
                });
            },
            computed: {
                realLines: function () {
                    return this.textareaVideosUrls.split('\n').length;
                },
                validUrlsCounter: function () {
                    return this.validVideos.length;
                },
                siteIsHttps: function () {
                    return window.location.protocol == "https:";
                },
                smtIsLoading: function () {
                    return this.loading.loadingData || this.loading.deleteFeed || this.partnerCatsLoading;
                },
                checkedVideosCounter: function () {
                    return this.videos.filter(function (video) {
                        return video.checked;
                    }).length;
                },
                selectedWPCatName: function () {
                    self = this;
                    if (this.selectedWPCat > 0) {
                        return lodash.find(self.data.WPCats, function (wpcat) {
                            return wpcat.term_id == self.selectedWPCat;
                        }).name;
                    }
                    return '...';
                },
                selectedPostStatusName: function () {
                    switch( this.selectedPostsStatus ){
                        case 'draft':
                            return 'Draft';
                        case 'publish':
                            return 'Published';
                        default:
                            return '...';
                    }
                },
                importProgress: function () {
                    var progress = (this.savedCheckedVideosCounter - this.checkedVideosCounter) / this.savedCheckedVideosCounter * 100;
                    if (this.importingVideos) {
                        return progress >= 100 ? 100 : progress;
                    }
                    return 0;
                },
                checkableVideosCounter : function(){
                    return this.videos.filter( function(video){
                        return !video.grabbed;
                    }).length;
                },
                allVideosChecked : function(){
                    return ( ( this.checkedVideosCounter == this.checkableVideosCounter ) && ( this.checkableVideosCounter > 0 ) );
                },
                videosCounter: function () {
                    return this.videos.length;
                },
                importBtnClass: function () {
                    if (this.selectedWPCat == 0 || this.selectedPostsStatus == 0 || this.importingVideos || this.checkedVideosCounter <= 0) {
                        return 'disabled';
                    }
                    return '';
                },
                importButtonTooltip: function () {
                    var title = '';
                    if (this.dataLoaded && this.checkedVideosCounter == 0) {
                        return this.data.objectL10n.check_least + ' ' + this.data.objectL10n.enable_button;
                    }
                    
                    if (this.dataLoaded && this.selectedPostsStatus == 0) {
                        return this.data.objectL10n.select_post_status + ' ' + this.data.objectL10n.enable_button;
                    }
                    if (this.dataLoaded && this.selectedWPCat == 0) {
                        return this.data.objectL10n.select_wp_cat + ' ' + this.data.objectL10n.enable_button;
                    }

                    return '';
                },
                addVideosButtonTooltip: function () {
                    var title = '';
                    if (this.validUrlsCounter <= 0) {
                        title += this.data.objectL10n.insert_least + ' ' + this.data.objectL10n.enable_button;
                    }
                
                    return title;
                }
            },
            filters: {
                timeFormat: function (timeInSeconds) {
                    var date = new Date(1970, 0, 1);
                    date.setSeconds(timeInSeconds);
                    return date.toTimeString().replace(/.*(\d{2}:\d{2}:\d{2}).*/, "$1");
                },
                addZero: function (number) {
                    if (number < 10)
                        number = '0' + number;
                    return number;
                }
            },
            methods: {
                resetSearch: function () {
                    this.videos                 = [];
                    this.videosResponses        = [];
                    this.videosHasBeenSearched  = false;
                    this.selectedWPCat          = 0;
                },
                updateDisplayType : function (displayType){
                    this.displayType = displayType;
                },
                addNewWpCategory : function (){
                    this.addingNewWpCategory = true;
                    var self = this;
                    self.$http.post(
                        AVUP_import_videos.ajax.url, {
                            action: 'AVUP_create_category',
                            nonce: AVUP_import_videos.ajax.nonce,
                            category_name: self.newWpCategoryName,
                        }, {
                            emulateJSON: true
                        })
                    .then(function (response) {
                        // success callback
                        this.data.WPCats = response.body.wp_cats;
                        setTimeout( function () {
                            jQuery('#cat_wp_select').selectpicker('refresh').selectpicker('val', response.body.new_cat_id);
                        }, 0);
                        
                    }, function (response) {
                        // error callback
                        console.error(response);
                    }).then(function () {
                        jQuery('#add-wp-cat-modal').modal('hide');
                        self.newWpCategoryName = '';
                        self.addingNewWpCategory = false;
                    });
                },
                parseTextarea : lodash.debounce(
                    function () {
                        var self = this;
                        // reset validVideos
                        self.validVideos = [];
                        // clean and validate user urls in textarea
                        this.textareaVideosUrls = lodash.map(this.textareaVideosUrls.split('\n'), function (currentLine) {
                          // preparing regex to find partnerId and videoId
                          var partnerId = '';
                          var videoId = '';
                          lodash.map(self.data.partners, function(partner) {
                            var match = currentLine.match(partner.regex);
                            if (match) {
                              partnerId = partner.id;
                              videoId = match[1];
                            }
                          });
                          console.log(partnerId, videoId);
                            // if current line is a valid url
                            if (partnerId && videoId) {
                                // if this video is not already in the validated ones
                                if (!lodash.find(self.validVideos, {
                                        'partnerId': partnerId,
                                        'videoId': videoId
                                })) {
                                    // push current line in validVideos
                                    self.validVideos.push({
                                        userUrl: currentLine,
                                        partnerId: partnerId,
                                        videoId: videoId
                                    });
                                }
                            }
                            // else return current line to leave (don't filter) it in the textarea
                            return currentLine;
                        }).join('\n');
                    }, 500
                ),
                addVideos: function (event) {
                    if(event.target.classList.contains('disabled')) return;

                    var self = this;
                    var localUrlsCounter = this.validUrlsCounter;
                    this.searchingVideos = true;
                    this.videosResponses = [];
                    lodash.each(this.validVideos, function (currentVideo) {
                        // video exists in the retrieved videos
                        if( lodash.findIndex( self.videos, function(existingVideo){
                            return existingVideo.id == currentVideo.videoId;
                        }) > -1 ){
                            self.videosResponses.push({
                                response:       {
                                    'code': 'info',
                                    'message': 'This video already exists in the retrieved videos just below'
                                },
                                userUrl:        currentVideo.userUrl
                            });
                            --localUrlsCounter;
                            if (localUrlsCounter <= 0) {
                                self.textareaVideosUrls     = '';
                                self.validVideos            = [];
                                self.videosHasBeenSearched  = true;
                                self.searchingVideos        = false;
                            }
                        }else{
                            // ajax request to find video data
                            self.$http.post(
                                AVUP_import_videos.ajax.url, {
                                    action: 'AVUP_search_video',
                                    nonce: AVUP_import_videos.ajax.nonce,
                                    video_url: currentVideo.userUrl,
                                    video_id: currentVideo.videoId,
                                    partner: lodash.find(self.data.partners, function (p) {
                                        return p.id == currentVideo.partnerId
                                    })
                                }, {
                                    emulateJSON: true
                                })
                            .then(function (response) {
                                if ( lodash.isEmpty(response.body.errors) ) {
                                    var video = response.body.video;
                                    self.videosResponses.push({
                                        response:       video.response,
                                        userUrl:        currentVideo.userUrl
                                    });
                                    if( video.id ){ 
                                        self.videos.push({
                                            id:             video.id,
                                            partner_id:     currentVideo.partnerId,
                                            title:          video.title,
                                            thumb_url:      video.thumb_url,
                                            thumbs_urls:    video.thumbs_urls.split(','),
                                            trailer_url:    video.trailer_url,
                                            desc:           video.desc,
                                            embed:          video.embed,
                                            tracking_url:   video.tracking_url,
                                            duration:       video.duration,
                                            actors:         video.actors,
                                            tags:           video.tags,
                                            video_url:      video.video_url,
                                            checked:        video.checked,
                                            grabbed:        video.grabbed,
                                        });
                                    }
                                } else {
                                    self.videosSearchedErrors = response.body.errors;
                                }
                                delete errors;
                                delete response;
                                delete videos;
                            }, function (response) {
                                // error callback
                                console.error(response);
                            }).
                            then(function () {
                                --localUrlsCounter;
                                if (localUrlsCounter <= 0) {
                                    self.textareaVideosUrls = '';
                                    self.validVideos = [];
                                    self.videosHasBeenSearched = true;
                                    self.searchingVideos = false;
                                }
                            });
                        }
                    });
                },
                toggleVideo: function (index, from) {
                    this.videos[index].checked = !this.videos[index].checked;
                },
                toogleAllVideos: function () {
                    var allVideosChecked = !this.allVideosChecked;
                    lodash.each(this.videos, function (video) {
                        if (!video.grabbed) {
                            video.checked = allVideosChecked;
                        }
                    });
                },
                setCurrentVideo: function (video, index) {
                    this.currentVideo = video;
                    this.currentVideoUrl = video.video_url ? video.video_url : null;
                    this.currentVideoEmbed = video.embed ? video.embed : null;
                    this.currentVideo.index = index;
                    this.expandedThumb = '';
                },
                prevVideoModal: function (index) {
                    var prevIndex = null;
                    if (index <= 0) {
                        prevIndex = this.videos.length - 1;
                    } else {
                        prevIndex = index - 1;
                    }
                    // var prevIndex = index <= 0 ? this.videos.length - 1 : index - 1;
                    this.currentVideo = this.videos[prevIndex];
                    this.currentVideoUrl = this.videos[prevIndex].video_url ? this.videos[prevIndex].video_url : null;
                    this.currentVideoEmbed = this.videos[prevIndex].embed ? this.videos[prevIndex].embed : null;
                    this.currentVideo.index = prevIndex;
                    this.expandedThumb = '';
                },
                nextVideoModal: function (index) {
                    var nextIndex = null;
                    if (index >= this.videos.length - 1) {
                        nextIndex = 0;
                    } else {
                        nextIndex = index + 1;
                    }
                    // var nextIndex = index >= this.videos.length - 1 ? 0 : index + 1;
                    this.currentVideo = this.videos[nextIndex];
                    this.currentVideoUrl = this.videos[nextIndex].video_url ? this.videos[nextIndex].video_url : null;
                    this.currentVideoEmbed = this.videos[nextIndex].embed ? this.videos[nextIndex].embed : null;
                    this.currentVideo.index = nextIndex;
                    this.expandedThumb = '';
                },
                showThumb: function (thumb) {
                    this.expandedThumb = thumb;
                },
                hideThumb: function () {
                    this.expandedThumb = '';
                },
                importVideos: function () {
                    if (this.importBtnClass == 'disabled') {
                        return;
                    }
                    //doing DOM stuff...
                    jQuery('#videos-found .progress-bar').removeClass('no-anim');
                    jQuery('.menu-icon-post .wp-menu-name').append(' <span class="update-posts"><span class="plugin-count"></span></span>');
                    var checkedVideosCounter = this.savedCheckedVideosCounter = this.checkedVideosCounter;
                    var cat_wp = this.selectedWPCat;
                    var status = this.selectedPostsStatus;
                    var total_videos = this.checkedVideosCounter;
                    this.videos.filter(function (video) {
                        return video.checked;
                    }).forEach(function (video) {
                        self.importingVideos = true;
                        self.$http.post(
                                AVUP_import_videos.ajax.url, {
                                    action: 'AVUP_import_video',
                                    nonce: AVUP_import_videos.ajax.nonce,
                                    cat_wp: cat_wp,
                                    status: status,
                                    partner_id : video.partner_id,
                                    video_infos: video
                                }, {
                                    emulateJSON: true
                                })
                            .then(function (response) {
                                if (response.body === -1) {
                                    console.error(response);
                                }
                                // success callback
                                video.grabbed = true;
                                video['checked'] = false;
                                console.log( video );
                                // display post creation notice
                                jQuery('.update-posts .plugin-count').text('+ ' + (self.savedCheckedVideosCounter - self.checkedVideosCounter));

                            }, function (response) {
                                // error callback
                                console.error(response);
                            }).then(function () {
                                if( --checkedVideosCounter <= 0 ){
                                    jQuery('#videos-found .progress-bar').addClass('no-anim');
                                    jQuery('#videos-found .progress').addClass('finished');
                                    var delay = setTimeout(function(){
                                        jQuery('#videos-found .progress').removeClass('finished');
                                        jQuery('.update-posts').remove();
                                        self.importingVideos = false;
                                        self.firstImport     = false;
                                    }, 2000);
                                }
                            });
                    });
                }
            },
            watch: {
                textareaVideosUrls: function(newValue, oldValue) {
                    this.textareaVideosUrls = this.textareaVideosUrls.replace('\n\n', '\n');
                    var localRealLines = this.textareaVideosUrls.split('\n').filter( function ( line, index, arr ){
                        //exclude last empty line
                        if( line === '' && index == arr.length - 1 ) return true;
                        return line !== '';
                    });
                    if( localRealLines.length > this.linesLimit ){
                        this.textareaVideosUrls = lodash.take(localRealLines, this.linesLimit ).join('\n');
                    }else{
                        this.textareaVideosUrls = localRealLines.join('\n');
                    }
                    this.parseTextarea();
                },
                selectedWPCat: function( newWpCat, oldWpCat ){
                    if( '+' == newWpCat ){
                        this.selectedWPCat = oldWpCat;
                        jQuery('#add-wp-cat-modal').modal('show');
                        jQuery('#cat_wp_select').selectpicker('val', oldWpCat);
                    }
                }
            },
            directives: {
                img: {
                    inserted: function (el, arg) {
                        // Focus the element
                        var img = new Image();
                        img.src = arg.value;
                        img.onload = function () {
                            el.src = arg.value;
                            var thumbWidth = jQuery(el)[0].getBoundingClientRect().width;
                        }
                    }
                }
            },
            components: {
                'bootstrap-select': {
                    props: ['value', 'options'],
                    template: `
                        <select>
                            <slot></slot>
                        </select>
                    `,
                    mounted: function () {
                        var vm = this;
                        jQuery(this.$el).selectpicker(this.options).on('rendered.bs.select', function () {
                            vm.$emit('input', this.value);
                        });
                    },
                    destroyed: function () {
                        jQuery(this.$el).selectpicker('destroy');
                    }
                },
            }
        });
    }
};
