<?php
// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
function AVUP_import_videos_page() {
	?>
<meta name="referrer" content="no-referrer"/>
<div id="wp-script">
	<div class="content-tabs">
		<div class="row">
			<div class="col-xs-12 padding-top-10 padding-bottom-10">
				<div class="logo"><h2><a href="https://www.wp-script.com" target="_blank"><img class="panda" src="<?php echo WPSCORE_URL; ?>admin/assets/images/logo-wp-script.svg" width="250"/></a></h2></div>
			</div>
		</div>
		<?php WPSCORE()->display_tabs(); ?>
		<div class="tab-content">
			<div class="tab-pane fade in active" id="import-videos">
				<div>
				<ul class="list-inline">
					<li class="active"><a href="admin.php?page=avup-import-videos"><i class="fa fa-cloud-download"></i> <?php _e( 'Import videos', AVUP_LANG ); ?></a></li>
					<li>|</li>
					<li><a href="admin.php?page=avup-options"><i class="fa fa-wrench"></i> <?php _e( 'Options', AVUP_LANG ); ?></a></li>
				</ul>
				</div>
				<div v-cloak class="padding-top-15">
					<div class="row text-center v-cloak--block">
						<div class="col-xs-12 loading"><p><i class="fa fa-cog fa-spin fa-2x fa-fw" aria-hidden="true"></i><br><?php _e( 'Loading Page', AVUP_LANG ); ?>...</span></p></div>
					</div>
					<div class="v-cloak--hidden">
						<!--**************-->
						<!-- LOADING DATA -->
						<!--**************-->
						<template v-if="loading.loadingData">
						<div class="row text-center">
							<div class="col-xs-12 loading"><p><i class="fa fa-cog fa-spin-reverse fa-2x fa-fw" aria-hidden="true"></i><br><?php _e( 'Loading Data', AVUP_LANG ); ?>...</span></p></div>
						</div>
						</template>
						<transition name="fade">
						<div v-if="dataLoaded">
							<!-- search videos block -->
							<div class="row">
							<div class="col-xs-12">
								<h3>
								<i class="fa fa-link" aria-hidden="true"></i> <?php _e( 'Import Tubes videos from their URL', AVUP_LANG ); ?>
								<button class="btn btn-default pull-right" data-toggle="modal" data-target="#available-tubes-modal"><i class="fa fa-bars" aria-hidden="true"></i> <?php _e( 'Available Tubes', AVUP_LANG ); ?></button>
								</h3>
								<div id="block-search" v-bind:class="{'margin-bottom-10' : videosCounter <= 0}">
								<div id="step-1" class="block-white block-white-first">
									<span class="step">1</span>
									<label for="videos_links"><?php _e( 'Add some videos urls to import', AVUP_LANG ); ?> <span v-if="realLines < linesLimit">({{linesLimit}} lines max at a time to prevent being banished from tubes)</span><strong class="text-danger" v-else>({{linesLimit}} lines max reached)</strong></label>
									<div class="clear margin-bottom-10"></div>
									<div class="row">
									<div class="col-xs-12 col-md-6">
										<textarea autofocus v-model="textareaVideosUrls" ref="videos_links" name="videos_links" class="form-control" rows="10" placeholder="Insert 1 video url per line"></textarea>
										<transition name="fade">
										<div v-show="textareaVideosUrls != ''" class="alert margin-top-20 margin-bottom-0" v-bind:class="[validVideos.length > 0 ? 'alert-success' : 'alert-warning']"><i v-show="this.validVideos.length > 0" class="fa fa fa-check" aria-hidden="true"></i> <strong>{{validVideos.length}}</strong> <?php _e( 'valid videos detected in', AVUP_LANG ); ?> {{realLines}}/{{linesLimit}} <?php _e( 'lines', AVUP_LANG ); ?>. <span v-show="this.validVideos.length > 0"><?php _e( 'Just click on the Retrieve videos button below', AVUP_LANG ); ?>.<span></div>
										</transition>
									</div>
									<div class="col-xs-12 col-md-6">
										<div id="videos-responses" class="panel panel-default margin-bottom-0">
										<div class="panel-body">
											<span v-if="videosResponses.length <= 0" class="text-muted"><em><?php _e( 'Here will be displayed feedback informations when retrieving videos', AVUP_LANG ); ?></em></span>
											<template v-else>
											<div v-for="(videoR, index) in videosResponses" v-bind:key="index" class="alert" v-bind:class="'alert-' + videoR.response.code" role="alert">
												<span class="video-response-index">{{index + 1}}</span>
												<small>
													<strong><a v-bind:href="videoR.userUrl" target="_blank" v-bind:class="'text-' + videoR.response.code">{{videoR.userUrl}} <i class="fa fa-external-link" aria-hidden="true"></i></a></strong>
													<br>
													<i class="fa" v-bind:class="[videoR.response.code == 'success' ? 'fa-check' : 'fa-chevron-circle-right']" aria-hidden="true"></i> <em v-html="videoR.response.message"></em>
												</small>
											</div>
											</template> 
										</div>
										</div>
									</div>
									</div>
								</div>
								<div id="step-2" class="block-white block-white-last" >
									<span class="step">2</span>
									<button class="btn btn-primary" v-bind:class="{'disabled' : validUrlsCounter <= 0}" v-on:click.prevent="addVideos" rel="tooltip" data-placement="top" v-bind:data-original-title="addVideosButtonTooltip"><i aria-hidden="true" class="fa" v-bind:class="[searchingVideos ? 'fa-spinner fa-pulse fa-fw':'fa-search']"></i> <template v-if="searchingVideos"><?php _e( 'Retrieving videos', AVUP_LANG ); ?></template><template v-else><?php _e( 'Retrieve videos', AVUP_LANG ); ?></template></button>
								</div>
								<!-- Available Tubes Modal -->
								<div class="modal fade" id="available-tubes-modal">
									<div class="modal-dialog modal-lg">
									<div class="modal-content">
										<div class="modal-header">
										<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only"><?php _e( 'Close', AVUP_LANG ); ?></span></button>
										<h4 class="modal-title"><?php _e( 'You can get videos from all these Adult Tubes', AVUP_LANG ); ?></h4>
										</div>
										<div class="modal-body">
										<div class="row">
											<div class="col-xs-12">
											<table class="table table-striped">
												<tr>
												<th><?php _e( 'Tube', AVUP_LANG ); ?></th>
												<th><?php _e( 'Video url example', AVUP_LANG ); ?></th>
												<th><?php _e( 'Affilate program', AVUP_LANG ); ?></th>
												</tr>
												<tr v-for="partner in data.partners">
												<td>
													<a v-bind:href="partner.home" target="_blank">
													<img class="border-radius-4" v-bind:src="'https://res.cloudinary.com/themabiz/image/upload/wpscript/sources/' + partner.id + '.jpg'" v-bind:alt="partner.name">
													</a>
												</td>    
												<td class="align-middle"><code>{{partner.video_url_eg}}</code></td>
												<td><a v-bind:href="partner.url" class="btn btn-default btn-block" target="_blank"><i class="fa fa-sign-in" aria-hidden="true"></i> Register</a></td>
												</tr>
											</table>
											</div>
										</div>
										</div>
									</div>
									</div>
								</div>
								<!-- /Available Tubes Modal -->
								</div>
							</div>
							</div>
							<!-- / search videos block -->
							<!-- results success block -->
							<div class="row">
							<div class="col-xs-12" v-show="videosCounter <= 0 && videosHasBeenSearched">
								<div v-if="videosSearchedErrors.code" class="alert alert-danger margin-top-10 text-center" role="alert">
								<p><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> <strong>{{videosSearchedErrors.code}}</strong><br>{{videosSearchedErrors.message}}<br>-<br>{{videosSearchedErrors.solution}}</p>
								</div>
							</div>
							<transition name="fade">
								<div v-show="videosCounter > 0" id="videos-found" class="col-xs-12 margin-top-10">
								<div id="sticky-space" class="col-xs-12"></div>
								<div id="videos-found-header" class="col-xs-12">
									<div id="videos-found-header-block" class="margin-bottom-10">
									<div class="form-inline">
										<div id="videos-found-header-left" class="pull-left">
										<span class="step">3</span>
										<button v-bind:disabled="importingVideos" v-on:click.prevent="toogleAllVideos" class="btn btn-default" id="bulk-checked" rel="0"><i class="fa" v-bind:class="[allVideosChecked ? 'fa-check-square-o':'fa-square-o']"></i> <span v-if="!allVideosChecked"><?php _e( 'Check all videos', AVUP_LANG ); ?></span><span v-else><?php _e( 'Uncheck all videos', AVUP_LANG ); ?></span></button>
										<bootstrap-select v-bind:disabled="importingVideos" id="post_status_select" v-model="selectedPostsStatus" v-bind:options="{'width':'fit'}">
											<option value="0">- <?php _e( 'Videos status', AVUP_LANG ); ?> -</option>
											<option value="draft"><?php _e( 'Draft', AVUP_LANG ); ?></option>
											<option value="publish"><?php _e( 'Publish', AVUP_LANG ); ?></option>
										</bootstrap-select>
										<bootstrap-select v-bind:disabled="importingVideos" id="cat_wp_select" v-model="selectedWPCat" v-bind:options="{'width':'fit', 'liveSearch':true}">
											<option value="0">- <?php _e( 'WP category', AVUP_LANG ); ?> -</option>
											<!-- incoming feature -->
											<option data-divider="true"></option>
											<option value="+"><strong>+ <?php _e( 'Add a new category', AVUP_LANG ); ?></strong></option>
											<!-- /incoming feature -->
											<option data-divider="true"></option>
											<option v-for="(WPCat, index) in data.WPCats" v-bind:value="WPCat.term_id" v-bind:key="WPCat.term_id">
											{{WPCat.name}}
											</option>
										</bootstrap-select>
										<button v-on:click.prevent="importVideos" v-bind:class="importBtnClass" type="submit" class="btn btn-success" rel="tooltip" data-placement="top" v-bind:data-original-title="importButtonTooltip">
											<span v-if="importingVideos">
											<i class="fa fa-spinner fa-pulse"></i> {{savedCheckedVideosCounter - checkedVideosCounter}}/{{savedCheckedVideosCounter}} <?php _e( 'videos imported in', AVUP_LANG ); ?> {{selectedWPCatName}}
											</span>
											<span v-else>
											<i class="fa fa-cloud-download"></i> <?php _e( 'Import', AVUP_LANG ); ?> {{checkedVideosCounter}} {{selectedPostStatusName}} <?php _e( 'Videos in', AVUP_LANG ); ?> {{selectedWPCatName}}
											</span>
										</button>
										</div>
										<div class="pull-right">
										<div id="display-type" class="btn-group">
											<button class="btn btn-default" v-bind:class="{'active':displayType == 'cards'}" v-on:click="updateDisplayType('cards')"><i class="fa fa-th" aria-hidden="true"></i></button>
											<button class="btn btn-default" v-bind:class="{'active':displayType == 'lists'}" v-on:click="updateDisplayType('lists')"><i class="fa fa-list-ul" aria-hidden="true"></i></button>
										</div>
										<button v-show="videosHasBeenSearched" v-on:click.prevent="resetSearch" v-bind:disabled="importingVideos" class="btn btn-danger"><span class="fa fa-times" aria-hidden="true"></span></button>
										</div>
									</div>
									<div class="clearfix"></div>
									</div>
									<div class="progress">
									<div class="progress-bar progress-bar-success" role="progressbar" v-bind:aria-valuenow="importProgress" aria-valuemin="0" aria-valuemax="100" v-bind:style="'width:' + importProgress + '%;'">
										<span><i aria-hidden="true" class="fa fa-check"></i> <?php _e( 'Import done!', AVUP_LANG ); ?></span>
									</div>
									</div>
								</div>
								<div id="videos" class="row" v-bind:class="displayType">
									<template v-if="displayType == 'cards'">
									<div v-for="(video, index) in videos" class="col-xs-12 col-sm-6 col-md-3 col-lg-2 item-cards" v-bind:key="video.id">
										<div class="video" v-bind:class="{'grabbed': video.grabbed, 'checked': video.checked}" >
										<div class="video-img" v-on:click.prevent="setCurrentVideo(video, index)">
											<img class="img-responsive" src="<?php echo AVUP_URL; ?>admin/assets/img/loading-thumb.gif" v-img="video.thumb_url" data-toggle="modal" data-target="#video-preview-modal" v-bind:alt="video.title" />
											<span class="video-partner" data-toggle="modal" data-target="#video-preview-modal"><img v-bind:src="'https://res.cloudinary.com/themabiz/image/upload/wpscript/sources/' + video.partner_id + '.jpg'" v-bind:alt="video.partner_id"></span>
											<span class="video-duration" data-toggle="modal" data-target="#video-preview-modal">{{video.duration | timeFormat}}</span>
										</div>
										<h4>{{video.title}}</h4>
										<div class="btn-group btn-group-justified" v-if="!video.grabbed">
											<div class="btn-group">
											<button v-on:click.prevent="toggleVideo(index, 'list')" class="btn text-center" v-bind:class="[video.checked ? 'btn-success':'btn-default']"><i class="fa-lg" v-bind:class="[video.checked ? 'fa fa-check-square-o':'fa fa-square-o']" aria-hidden="true"></i></button>
											</div>
											<div class="btn-group">
											<button v-on:click.prevent="setCurrentVideo(video, index)" type="button" class="btn btn-default text-center video-preview" data-toggle="modal" data-target="#video-preview-modal">
												<i class="fa fa-pencil" aria-hidden="true"></i>
											</button>
											</div>
										</div>
										<button v-else class="btn text-center btn-block disabled"><?php _e( 'Video imported', AVUP_LANG ); ?></button>
										</div>
									</div>
									</template>
									<template v-else>
									<div class="col-xs-12">
										<div class="panel panel-default margin-bottom-10">
										<table class="table table-striped table-hover table-bordered">
											<tr>
											<th width="35"></th>
											<th width="100"><?php _e( 'Thumb', AVUP_LANG ); ?></th>
											<th><?php _e( 'Title', AVUP_LANG ); ?></th>
											<th><?php _e( 'Description', AVUP_LANG ); ?></th>
											<th><?php _e( 'Tags and Actors', AVUP_LANG ); ?></th>
											</tr>
											<tr v-for="(video, index) in videos" v-bind:key="video.id" class="item-list" v-bind:class="{'success':video.checked, 'grabbed':video.grabbed}">
											<td v-if="!video.grabbed" class="item-list-toggle" width="35" v-on:click.prevent="toggleVideo(index, 'list')">
												<i class="fa-lg" v-bind:class="[video.checked ? 'fa fa-check-square-o text-success':'fa fa-square-o']" aria-hidden="true"></i>
											</td>
											<td v-else class="item-list-toggle" width="35"></td>
											<td width="100">
												<img v-if="!video.grabbed" width="100" v-on:click.prevent="setCurrentVideo(video, index)" class="pointer" src="<?php echo AVUP_LANG; ?>admin/assets/img/loading-thumb.gif" v-img="video.thumb_url" data-toggle="modal" data-target="#video-preview-modal" v-bind:alt="video.title" />
												<img v-else width="100"  src="<?php echo AVUP_LANG; ?>admin/assets/img/loading-thumb.gif" v-img="video.thumb_url" v-bind:alt="video.title" />
												<img width="100" v-bind:src="'https://res.cloudinary.com/themabiz/image/upload/wpscript/sources/' + video.partner_id + '.jpg'" v-bind:alt="video.partner_id">
											</td>
											<template v-if="video.grabbed">
												<td colspan="3" class="video-td-imported"><?php _e( 'Video imported', AVUP_LANG ); ?></td>
											</template>
											<template v-else>
												<td>
												<div class="margin-bottom-5"><input type="text" name="" v-model="video.title" v-bind:disabled="video.grabbed" class="form-control" placeholder="<?php _e( 'Title', AVUP_LANG ); ?>..."></div>
												<template v-if="video.duration"><i class="fa fa-clock-o" aria-hidden="true"></i> <small>{{video.duration | timeFormat}}</small></template>
												</td>
												<td>
												<textarea placeholder="<?php _e( 'Description', AVUP_LANG ); ?>..." name="" v-model="video.desc" v-bind:disabled="video.grabbed" class="form-control"></textarea>
												</td>
												<td>
												<div class="input-group margin-bottom-8">
													<span class="input-group-addon" id="actors"><i class="fa fa-users" aria-hidden="true"></i> <small><?php _e( 'Actors', AVUP_LANG ); ?></small></span>
													<input type="text" name="actors" class="form-control" v-model="video.actors" v-bind:disabled="video.grabbed" placeholder="insert actors separated by a comma" aria-describedby="actors">
												</div>
												<div class="input-group">
													<span class="input-group-addon" id="tags"><i class="fa fa-tags" aria-hidden="true"></i> <small><?php _e( 'Tags', AVUP_LANG ); ?></small></span>
													<input type="text" name="tags" class="form-control" v-model="video.tags" v-bind:disabled="video.grabbed" placeholder="insert tags separated by a comma" aria-describedby="tags">
												</div>
												</td>
											</template>
											</tr>
										</table>
										</div>
									</div>
									</template>
									<div class="clear"></div>
									<!-- Create WP Cat Modal -->
									<div class="modal fade" id="add-wp-cat-modal">
									<div class="modal-dialog" role="document">
										<div class="modal-content">
										<div class="modal-header">
										<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only"><?php _e( 'Close', AVUP_LANG ); ?></span></button>
										<h4 class="modal-title"><?php _e( 'Add a new WordPress Category', AVUP_LANG ); ?></h4>
										</div>
										<div class="modal-body">
											<div class="row">
											<div class="col-xs-12 margin-bottom-5">
												<div class="input-group">
													<span class="input-group-addon" id="new_category_name"><?php _e( 'Name', AVUP_LANG ); ?></span>
													<input type="text" name="new_category_name" class="form-control" v-model="newWpCategoryName" placeholder="New category name" aria-describedby="new category name">
												</div>
											</div>
											</div>
										</div>
										<div class="modal-footer">
											<div class="row">
											<div class="col-xs-12">
												<button class="btn btn-default" data-dismiss="modal">Cancel</button>
												<button class="btn btn-primary" v-bind:class="{'disabled': !newWpCategoryName || addingNewWpCategory}" v-on:click="addNewWpCategory">
												<template v-if="addingNewWpCategory">
													<i class="fa fa-spinner fa-pulse"></i> <?php _e( 'Adding', AVUP_LANG ); ?> {{newWpCategoryName}}
												</template>
												<template v-else>
													<?php _e( 'Add New Category', AVUP_LANG ); ?>
												</template>
												</button>
											</div>
											</div>
										</div>
										</div>
									</div>
									</div>
									<!-- /Create WP Cat Modal -->
									<!-- Video Modal -->
									<div class="modal fade" id="video-preview-modal" tabindex="-1" role="dialog">
										<div class="modal-dialog">
											<div class="modal-content">
												<div class="modal-header">
													<div class="row">
													<div class="col-xs-11">
														<input type="text" name="" v-model="currentVideo.title" v-bind:disabled="currentVideo.grabbed" class="form-control" placeholder="<?php _e( 'Title', AVUP_LANG ); ?>...">
													</div>
													<div class="col-xs-1">
														<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
													</div>
													</div>
												</div>
												<div class="modal-body" v-bind:key="currentVideo.id">
													<div class="row">
														<div class="col-xs-12">
															<ul class="nav nav-tabs padding-top-15" role="tablist">
																<li class="active"><a href="#current-video-data" role="tab" data-toggle="tab"><i class="fa fa-youtube-play" aria-hidden="true"></i> <?php _e( 'Video data', AVUP_LANG ); ?></a></li>
																<li v-if="currentVideo.thumbs_urls != ''"><a href="#current-video-thumbs" role="tab" data-toggle="tab"><i class="fa fa-th-large" aria-hidden="true"></i></span> <?php _e( 'Thumbnails', AVUP_LANG ); ?></a></li>
																<li v-if="currentVideo.trailer_url != ''"><a href="#current-video-trailer" role="tab" data-toggle="tab"><i class="fa fa-file-video-o" aria-hidden="true"></i></span> <?php _e( 'Trailer', AVUP_LANG ); ?></a></li>
															</ul>
															<div class="tab-content">
															<div role="tabpanel" class="tab-pane active" id="current-video-data">
																<div class="row">
																	<div class="col-xs-12">
																		<template v-if="currentVideoEmbed">
																			<div v-if="currentVideo.partner_id == 'xvideos'">
																				<img class="img-responsive" v-bind:src="currentVideo.thumb_url">
																				<div class="alert alert-info text-center"><small>xVideos iframes are well imported but viewable on the frontend only.</small></div>
																			</div>
																			<div v-else v-html="currentVideoEmbed" class="embed-responsive embed-responsive-16by9"></div>
																		</template>
																	</div>
																</div>
																<div class="row padding-top-15">
																	<div class="col-xs-12 form-horizontal">
																		<div class="form-group">
																			<label for="actors" class="col-sm-2 control-label">Actors:</label>
																			<div class="col-sm-10">
																				<input type="text" name="actors" class="form-control" v-model="currentVideo.actors" v-bind:disabled="currentVideo.grabbed" placeholder="insert actors separated by a comma">
																			</div>
																		</div>
																		<div class="form-group">
																			<label for="tags" class="col-sm-2 control-label">Tags:</label>
																			<div class="col-sm-10">
																				<input type="text" name="tags" class="form-control" v-model="currentVideo.tags" v-bind:disabled="currentVideo.grabbed" placeholder="insert tags separated by a comma">
																			</div>
																		</div>
																	</div>
																</div>
																<div class="row">
																	<div class="col-xs-12">
																		<textarea placeholder="<?php _e( 'Description', AVUP_LANG ); ?>..." rows="5" name="" v-model="currentVideo.desc" v-bind:disabled="currentVideo.grabbed" class="form-control"></textarea>
																	</div>
																</div>
															</div>
															<div role="tabpanel" class="tab-pane" id="current-video-thumbs">
																<div v-if="currentVideo.thumbs_urls != ''" class="row">
																<transition name="fade" mode="out-in">
																	<div v-if="expandedThumb == ''" key="allThumbs"> 
																		<div v-for="thumb in currentVideo.thumbs_urls" v-bind:key="thumb" class="col-xs-6 col-md-3 item">
																			<img class="img-responsive thumbnail" v-bind:src="thumb" v-on:click="showThumb(thumb)">
																		</div>
																	</div>
																	<div v-if="expandedThumb != ''" class="col-xs-12 item" key="expandedThumb">
																		<img class="img-responsive thumbnail" style="width:100%;" v-bind:src="expandedThumb" v-on:click="hideThumb">
																	</div>
																</transition>
																<div class="col-xs-12">
																	<p class="padding-top-10 "><?php echo sprintf( __( 'The thumbnails are used by <a href="%s" target="_blank">WP-Script themes</a> to display a preview thumbnails rotation when hovering a video thumbnail.', AVUP_LANG ), 'https://www.wp-script.com/themes' ); ?></p>
																</div>
																</div>
															</div>
															<div role="tabpanel" class="tab-pane" id="current-video-trailer">
																<div v-if="currentVideo.trailer_url != ''" class="row">
																	<div class="col-xs-12">
																		<div class="embed-responsive embed-responsive-16by9">
																			<video controls class="embed-responsive-item" v-bind:poster="currentVideo.thumb_url">
																				<source v-bind:src="currentVideo.trailer_url">
																			</video>
																		</div>
																		<div class="col-xs-12">
																			<p class="padding-top-10 "><?php echo sprintf( __( 'The trailer is used by <a href="%s" target="_blank">WP-Script themes</a> to display a preview video when hovering a video thumbnail.', AVUP_LANG ), 'https://www.wp-script.com/themes' ); ?></p>
																		</div>
																	</div>
																</div>
															</div>
														</div>
													</div>
												</div>
												<div class="modal-footer">
													<div class="row">
													<div class="col-xs-3 col-md-3">
														<button v-show="videos.length >= 2" v-on:click.prevent="prevVideoModal(currentVideo.index)" type="button" class="btn btn-default btn-block"><i class="fa fa-arrow-left"></i></button>
													</div>
													<div class="col-xs-6 col-md-6">
														<button v-if="!currentVideo.grabbed" v-on:click.prevent="toggleVideo(currentVideo.index, 'modal')" type="button" class="btn btn-block" v-bind:class="[currentVideo.checked ? 'btn-success':'btn-default']"><i class="fa-lg" v-bind:class="[currentVideo.checked ? 'fa fa-check-square-o':'fa fa-square-o']" aria-hidden="true"></i> <span v-if="!currentVideo.checked"><?php _e( 'Check this video', AVUP_LANG ); ?></span><span v-else><?php _e( 'Uncheck this video', AVUP_LANG ); ?></span></button>
														<button v-else type="button" class="btn btn-default btn-block" disabled><?php _e( 'Video grabbed', AVUP_LANG ); ?></button>
													</div>
													<div class="col-xs-3 col-md-3">
														<button v-show="videos.length >= 2" v-on:click.prevent="nextVideoModal(currentVideo.index)" type="button" class="btn btn-default btn-block"><i class="fa fa-arrow-right"></i></button>
													</div>
													</div>
												</div>
											</div>
										</div>
									</div>
									<!--/ video modal-->
								</div>
								</div>
							</transition>
							</div>
							<!-- /results success block -->
						</div>
						</transition>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
	<?php
}
