<?php

/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
namespace Google\Site_Kit_Dependencies\Google\Service\AnalyticsReporting;

class SegmentFilterClause extends \Google\Site_Kit_Dependencies\Google\Model
{
    protected $dimensionFilterType = \Google\Site_Kit_Dependencies\Google\Service\AnalyticsReporting\SegmentDimensionFilter::class;
    protected $dimensionFilterDataType = '';
    protected $metricFilterType = \Google\Site_Kit_Dependencies\Google\Service\AnalyticsReporting\SegmentMetricFilter::class;
    protected $metricFilterDataType = '';
    /**
     * @var bool
     */
    public $not;
    /**
     * @param SegmentDimensionFilter
     */
    public function setDimensionFilter(\Google\Site_Kit_Dependencies\Google\Service\AnalyticsReporting\SegmentDimensionFilter $dimensionFilter)
    {
        $this->dimensionFilter = $dimensionFilter;
    }
    /**
     * @return SegmentDimensionFilter
     */
    public function getDimensionFilter()
    {
        return $this->dimensionFilter;
    }
    /**
     * @param SegmentMetricFilter
     */
    public function setMetricFilter(\Google\Site_Kit_Dependencies\Google\Service\AnalyticsReporting\SegmentMetricFilter $metricFilter)
    {
        $this->metricFilter = $metricFilter;
    }
    /**
     * @return SegmentMetricFilter
     */
    public function getMetricFilter()
    {
        return $this->metricFilter;
    }
    /**
     * @param bool
     */
    public function setNot($not)
    {
        $this->not = $not;
    }
    /**
     * @return bool
     */
    public function getNot()
    {
        return $this->not;
    }
}
// Adding a class alias for backwards compatibility with the previous class name.
\class_alias(\Google\Site_Kit_Dependencies\Google\Service\AnalyticsReporting\SegmentFilterClause::class, 'Google\\Site_Kit_Dependencies\\Google_Service_AnalyticsReporting_SegmentFilterClause');
